#!/usr/bin/python

# Download CryptoPhoto Python lib from https://cryptophoto.com/admin/api
from CryptoPhotoUtils import CryptoPhotoUtils
import cgi, hashlib, os

server      = "https://cryptophoto.com";
private_key = "xxx"; # Your CryptoPhoto Private API Key
public_key  = "yyy"; # Your CryptoPhoto Public API Key
salt        = "random-salt-string";
uid         = "userId"; # Your users internal ID

POST = cgi.FieldStorage()

step = 'register'
error = ''
sid = ''

if 'username' in POST:
  if POST['username'].value == 'demo':
    # do CryptoPhoto Wizard
    step = 'cp_wizard'
  else:
    error = 'Registration invalid'

if step == 'cp_wizard':

  cp = CryptoPhotoUtils(server, private_key, public_key, hashlib.sha1(uid + salt).hexdigest())
  cp.start_session(cgi.escape(os.environ["REMOTE_ADDR"]))

  if cp.is_valid:
    sid = cp.sid
  else:
    error = cp.error + cp.errdesc

display = ''

if error != '':
  display = '<p>Error: ' + error + '</p>';

if step == 'register':
  display += ('Username: <input type="text" name="username" value="demo"><br>'
    '<input type="submit" value="Register">')
elif step == 'cp_wizard':
  display += ('<div id="cp_widget" style="margin: 10px auto">Loading...</div>'
    '<script type="text/javascript"'
    'src="' + server + '/api/wizard-setup?sd=' + sid + '"></script>')

out = '''Content-Type: text/html; charset=utf-8

<!DOCTYPE html>
<html>
<head>
<meta charset='UTF-8'>
<title>User Register</title>
</head>

<body style='text-align:center'>
  <h2>User Register</h2>
  <form action='' method='post'>
    {display}
  </form>
</body>
</html>'''

out = out.format(display=display)

print out